/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CreateCveRecordRejectionResponseCreatedContainers type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateCveRecordRejectionResponseCreatedContainers{}

// CreateCveRecordRejectionResponseCreatedContainers struct for CreateCveRecordRejectionResponseCreatedContainers
type CreateCveRecordRejectionResponseCreatedContainers struct {
	Cna *CreateCveRecordRejectionResponseCreatedContainersCna `json:"cna,omitempty"`
}

// NewCreateCveRecordRejectionResponseCreatedContainers instantiates a new CreateCveRecordRejectionResponseCreatedContainers object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateCveRecordRejectionResponseCreatedContainers() *CreateCveRecordRejectionResponseCreatedContainers {
	this := CreateCveRecordRejectionResponseCreatedContainers{}
	return &this
}

// NewCreateCveRecordRejectionResponseCreatedContainersWithDefaults instantiates a new CreateCveRecordRejectionResponseCreatedContainers object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateCveRecordRejectionResponseCreatedContainersWithDefaults() *CreateCveRecordRejectionResponseCreatedContainers {
	this := CreateCveRecordRejectionResponseCreatedContainers{}
	return &this
}

// GetCna returns the Cna field value if set, zero value otherwise.
func (o *CreateCveRecordRejectionResponseCreatedContainers) GetCna() CreateCveRecordRejectionResponseCreatedContainersCna {
	if o == nil || IsNil(o.Cna) {
		var ret CreateCveRecordRejectionResponseCreatedContainersCna
		return ret
	}
	return *o.Cna
}

// GetCnaOk returns a tuple with the Cna field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainers) GetCnaOk() (*CreateCveRecordRejectionResponseCreatedContainersCna, bool) {
	if o == nil || IsNil(o.Cna) {
		return nil, false
	}
	return o.Cna, true
}

// HasCna returns a boolean if a field has been set.
func (o *CreateCveRecordRejectionResponseCreatedContainers) HasCna() bool {
	if o != nil && !IsNil(o.Cna) {
		return true
	}

	return false
}

// SetCna gets a reference to the given CreateCveRecordRejectionResponseCreatedContainersCna and assigns it to the Cna field.
func (o *CreateCveRecordRejectionResponseCreatedContainers) SetCna(v CreateCveRecordRejectionResponseCreatedContainersCna) {
	o.Cna = &v
}

func (o CreateCveRecordRejectionResponseCreatedContainers) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateCveRecordRejectionResponseCreatedContainers) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Cna) {
		toSerialize["cna"] = o.Cna
	}
	return toSerialize, nil
}

type NullableCreateCveRecordRejectionResponseCreatedContainers struct {
	value *CreateCveRecordRejectionResponseCreatedContainers
	isSet bool
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainers) Get() *CreateCveRecordRejectionResponseCreatedContainers {
	return v.value
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainers) Set(val *CreateCveRecordRejectionResponseCreatedContainers) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainers) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainers) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateCveRecordRejectionResponseCreatedContainers(val *CreateCveRecordRejectionResponseCreatedContainers) *NullableCreateCveRecordRejectionResponseCreatedContainers {
	return &NullableCreateCveRecordRejectionResponseCreatedContainers{value: val, isSet: true}
}

func (v NullableCreateCveRecordRejectionResponseCreatedContainers) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateCveRecordRejectionResponseCreatedContainers) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


